<template>
    <div>
        <h1>Hi {{user.fullName}}!</h1>
        <DataTable :value="users.items" :paginator="true" :rows="page.rows" :first="page.first"
                   :total-records="users.total"
                   dataKey="id" :rowHover="true"
                   paginatorTemplate="FirstPageLink PrevPageLink PageLinks NextPageLink LastPageLink CurrentPageReport RowsPerPageDropdown"
                   :rowsPerPageOptions="[1,2,3]"
                   currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries" :lazy="true"
                   v-on:update:rows="function(data) {page.rows = data} "
                   v-on:update:first="function(data) {page.first = data} ">
            <template #header>
                <div style="line-height:1.87em" class="p-clearfix">
                    <Button icon="pi pi-plus" style="float: left" title="Add new user" @click="updateUser(null)"/>
                    <Button icon="pi pi-key" style="float: left; left: 10px" title="Change password" @click="changePass"/>
                    List of user
                </div>
            </template>
            <Column field="username" header="Username"></Column>
            <Column field="email" header="Email"></Column>
            <Column field="fullName" header="Full name"></Column>
            <Column field="dob" header="Birthday">
                <template #body="slotProps">
                    {{new Date(slotProps.data.dob).toLocaleDateString()}}
                </template>
            </Column>
            <Column field="isAdmin" header="User type">
                <template #body="slotProps">
                    {{slotProps.data.isAdmin === 1 ? 'Admin' : 'Normal User'}}
                </template>
            </Column>
            <Column headerStyle="width: 8em" bodyStyle="text-align: center">
                <template #header>
                </template>
                <template #body="slotProps">
                    <Button type="button" icon="pi pi-pencil" class="p-button-warning" style="margin-right: .5em"
                            title="Edit user" @click="updateUser(slotProps.data)"></Button>
                    <Button type="button" icon="pi pi-trash" class="p-button-danger" title="Delete user"
                            v-if="user.username !== slotProps.data.username"
                            @click="deleteUser(slotProps.data)"></Button>
                </template>
            </Column>
        </DataTable>

        <p>
            <router-link to="/login">Logout</router-link>
        </p>
        <DialogEditUser :dialogVisible="showDialog" :user="userEdit" @closeRequest="closeDialog()"
                        :lb-btn="userEdit.id == null ? 'Add' : 'Update'"/>
        <ConfirmDelDialog :dialogVisible="showDialogDel" @closeRequest="closeDialog()"
                          :header-name="'Delete user ' + userEdit.username" :id-delete="userEdit.id"/>
        <ChangePassDialog :dialogVisible="showDialogPass" @closeRequest="closeDialog"/>
    </div>
</template>

<script>
    import {mapState, mapActions} from 'vuex'
    import ChangePassDialog from '../components/dialog/ChangePassDialog'
    import DialogEditUser from '../components/dialog/DialogEditUser'
    import ConfirmDelDialog from '../components/dialog/ConfirmDelDialog'

    export default {
        data() {
            return {
                showDialog: false,
                showDialogDel: false,
                showDialogPass: false,
                userEdit: {},
                page: {
                    first: 0,
                    rows: 1
                },
                updateYourSelf: false
            }
        },
        components: {
            DialogEditUser, ConfirmDelDialog, ChangePassDialog
        },
        computed: {
            ...mapState({
                account: state => state.account,
                users: state => state.users.all,
                msgUpdate: state => state.users.message,
                isOk: state => state.users.isOk,
                user: state => state.users.user
            })
        },
        created() {
            this.getAllUsers([this.page.first, this.page.rows]);
            this.getUser();
        },
        watch: {
            page: {
                handler: function () {
                    this.getAllUsers([Math.floor(this.page.first / this.page.rows), this.page.rows]);
                }, deep: true
            },
            msgUpdate: function () {
                this.$emit('showErrorEdit', this.msgUpdate);
            }
        },
        mounted() {
            this.$on('showErrorEdit', msg => {
                if (msg === '' || this.isOk === undefined)
                    return;
                if (this.isOk) {
                    this.$toast.add({severity: 'success', summary: 'Message', detail: msg, life: 3000});
                    if (!this.showDialogPass)
                        this.getAllUsers([this.page.first, this.page.rows]);
                    if(this.updateYourSelf){
                        this.updateYourSelf = false;
                        this.getUser();
                    }
                    this.closeDialog();
                } else {
                    const items = msg.split("|");
                    for (let i = 0; i < items.length; i++) {
                        this.$toast.add({severity: 'error', summary: 'Message Error', detail: items[i], life: 3000})
                    }
                }
                this.clearMessage();
            })
        },
        methods: {
            ...mapActions('users', {
                getAllUsers: 'getAll',
                getUser: 'getUser',
                clearMessage: 'clearMessage'
            }),
            updateUser(item) {
                this.showDialog = true;
                if (item != null) {
                    this.userEdit = Object.assign({}, item);
                    this.userEdit.dob = new Date(item.dob);
                    if(item.username === this.user.username)
                        this.updateYourSelf = true;
                }

            },
            deleteUser(item) {
                this.showDialogDel = true;
                this.userEdit = Object.assign({}, item);
            },
            changePass() {
                this.showDialogPass = true;
            },
            closeDialog() {
                if (this.showDialog)
                    this.showDialog = false;
                if (this.showDialogDel)
                    this.showDialogDel = false;
                this.showDialogPass = false;
                this.userEdit = {};
            }
        }
    };
</script>
